part of slang_retail_assistant;

class SearchUserJourney {
  SearchUserJourney._();

  static MethodChannel _channel;

  static SearchContext getContext() {
    SearchContext._channel = _channel;
    return const SearchContext();
  }

  static void shouldPreserveContext() {
    _channel.invokeMethod("enableSearchUserJourneyContext");
  }

  static void disablePreserveContext() {
    _channel.invokeMethod("disableSearchUserJourneyContext");
  }

  void setSearchSuccess() {
    _channel.invokeMethod("setSearchSuccess");
  }

  void setSearchFailure() {
    _channel.invokeMethod("setSearchFailure");
  }

  void setItemNotFound() {
    _channel.invokeMethod("setSearchItemNotFound");
  }

  void setItemOutOfStock() {
    _channel.invokeMethod("setSearchItemOutOfStock");
  }

  void setItemNotSpecified() {
    _channel.invokeMethod("setSearchItemNotSpecified");
  }

  void setNeedItemQuantity() {
    _channel.invokeMethod("setSearchNeedItemQuantity");
  }

  void setNeedDisambiguation() {
    _channel.invokeMethod("setSearchNeedDisambiguation");
  }

  void setStopDisambiguation() {
    _channel.invokeMethod("setSearchStopDisambiguation");
  }

  void setUserJourneyToContinue(AssistantUserJourney assistantUserJourney,
      bool isSpoken) {
    _channel.invokeMapMethod("setUserJourneyToContinue", {
      "currentUserJourney": AssistantUserJourney.SEARCH.stringValue,
      "userJourneyToContinue": assistantUserJourney.stringValue,
      "isSpoken": isSpoken
    });
  }

  void clearUserJourneyToContinue() {
    _channel.invokeMapMethod("setUserJourneyToContinue", {
      "currentUserJourney": AssistantUserJourney.SEARCH.stringValue
    });
  }

  void notifyAppState(SearchAppState appState) {
    _channel.invokeMapMethod(
        "notifySearchActionCompleted", {"appState": appState.stringValue});
  }
}

class SearchContext {
  const SearchContext();
  static MethodChannel _channel;
  void clear() {
    _channel.invokeMethod("clearSearchUserJourneyContext");
  }
}

enum SearchAppState { UNSUPPORTED, WAITING, SEARCH_RESULTS, ADD_TO_CART }

extension SearchAppStateExtension on SearchAppState {
  String get stringValue {
    switch (this) {
      case SearchAppState.UNSUPPORTED:
        return 'unsupported';
      case SearchAppState.WAITING:
        return 'waiting';
      case SearchAppState.SEARCH_RESULTS:
        return 'search_results';
      case SearchAppState.ADD_TO_CART:
        return 'add_to_cart';
      default:
        return null;
    }
  }
}

enum AssistantUserJourney { SEARCH }

extension AssistantUserJourneyExtention on AssistantUserJourney {
  String get stringValue {
    switch (this) {
      case AssistantUserJourney.SEARCH:
        return 'retail_search';
      default:
        return "retail_search";
    }
  }
}
